#include "ErrorText.h"

namespace {
    char ERROR_TEXT[] = "error.txt";
    const bool PUT_NEW_LINE = true;
    const bool SERIAL_NUMBER = true;
}

ErrorTexts::~ErrorTexts() {
}

ErrorTexts::ErrorTexts(std::string b, std::string e, std::string m) {
    base = b;
    extension = e;
    messages = m;
    new_line = false;
}

ErrorTexts::ErrorTexts(std::string b, std::string e, std::string m, bool n) {
    base = b;
    extension = e;
    messages = m;
    new_line = n;
}

bool ErrorTexts::setting() {
    using namespace std;

    bool written = false;
    int error_number;
    stringstream os;
    TimeNames t(base, extension);

    file_name = t.temporaryName(SERIAL_NUMBER);

    try {
        ofstream errorFile( file_name.c_str() );
        errorFile.exceptions(ios_base::failbit);

        if( new_line ) {
            errorFile << messages << endl;
            written = true;
        } else {
            errorFile << messages;
            written = true;
        }

    } catch(...) {
        error_number = 281;
        os << "setting() error-" << error_number << ": " << file_name;

        MessagesTexts m(ERROR_TEXT, os.str(), PUT_NEW_LINE);
        m.setting();
        exit(error_number);
    }

    return written;
}

std::string ErrorTexts::errorFileName() const {
    return file_name;
}

