#include "FieldsArray.h"

namespace {
    const int UPPER_LIMIT_TO_FIELD_NUMBER = 3071; // F_SIZE - 1
    const std::string EMPTY = "";
}

int FieldsList::itemCount() const {
    return count;
}

std::string FieldsList::item(int i) {
    std::string s = EMPTY;

    if( i < 0 ) {
        exit(104);
    } else if( i >= UPPER_LIMIT_TO_FIELD_NUMBER ) {
        exit(105);
    } else {
        s = fields_list[i];
    }

    return s;
}

FieldsList::~FieldsList() {
}

FieldsList::FieldsList() {
    count = 0;

    for(int i = 0; i <= UPPER_LIMIT_TO_FIELD_NUMBER; ++i) {
        fields_list[i] = EMPTY;
    }

}

void FieldsList::setting(std::string & s, int i) {
    if( i < 0 ) {
        exit(106);
    } else if( i > UPPER_LIMIT_TO_FIELD_NUMBER ) {
        exit(107);
    } else {
        fields_list[i] = s;
        count += 1;
    }

}

