#include "Guide.h"

Guiding::~Guiding() {
}

Guiding::Guiding() {
}

void Guiding::versionGuide(double d, bool comments) {
    using namespace std;

    stringstream os;
    os << d;

    version_sequence = os.str();
    version_value = d;
    versionGuide(version_sequence, comments);
}

void Guiding::versionGuide(std::string & v, bool comments) {
    using namespace std;

    stringstream ss;
    ss >> version_value;

    version_sequence = v;

    cout << "Sjisutf16 C++ Version " << v << "\n" << endl;

    if( comments ) {
        cout << "sjisutf16 -% SJIS               # BOM precedes UTF-16 data. " << endl 
          << "sjisutf16 -0 SJIS               # Every line includes 0Dh. " << endl 
          << "sjisutf16 -a SJIS               # Acquire a table name from set_sjisutf16.txt " << endl 
          << "sjisutf16 -B SJIS               # Check line length. " << endl 
          << "sjisutf16 -b -y SJIS            # Do not remove binary.tmp " << endl 
          << "sjisutf16 -b SJIS               # Produce binary.tmp " << endl 
          << "sjisutf16 -b SJIS SJIS          # Produce and rename binary.tmp " << endl 
          << "sjisutf16 -d SJIS               # Do not search a table. " << endl 
          << "sjisutf16 -G                    # Guide " << endl 
          << "sjisutf16 -LF SJIS              # 0Dh is removed from every line. " << endl 
          << "sjisutf16 -l SJIS               # Count lines. " << endl 
          << "sjisutf16 -o UTF16 SJIS         # Produce a new file. " << endl 
          << "sjisutf16 -s SJIS               # Remove control characters. " << endl 
          << "sjisutf16 -t SJIS UTF16         # SJIS has the same time as UTF16. " << endl 
          << "sjisutf16 -V                    # Version " << endl 
          << "sjisutf16 -w SJIS               # -w shows which table sjisutf16 uses." << endl 
          << "sjisutf16 SJIS                  # Produce sjisutf16.txt " << endl 
          << "sjisutf16 SJIS UTF16            # Produce a new file. " << endl 
          << "TYPE SJIS | sjisutf16 -o UTF16  # standard input " << endl;
    } else {
        cout << "sjisutf16 --help               " << endl;
    }

}
