#include "Ucombo.h"

namespace {
    const char TAB = 9; // 09h 
    const int H_000000FF = 255;
    const std::string EMPTY = "";
}

UniversalComboAppend::~UniversalComboAppend() {
    delete combo;
}

UniversalComboAppend::UniversalComboAppend() {
    using namespace std;

    combo = new stringstream();
    separator = TAB;
}

UniversalComboAppend::UniversalComboAppend(char c) {
    using namespace std;

    combo = new stringstream();
    separator = c;
}

UniversalComboAppend::UniversalComboAppend(std::string & s) {
    using namespace std;

    combo = new stringstream();
    separator = (char)singleByte(s);
}

std::string UniversalComboAppend::built() {
    using namespace std;

    return combo->str();
}

int UniversalComboAppend::comboSize() {
    using namespace std;

    std::string s = combo->str();
    return s.length();
}

unsigned char UniversalComboAppend::singleByte(std::string & s) {
    char c[C_SIZE];
    const int C_SIZE_1 = C_SIZE - 1;
    int i;
    unsigned char u;

// Providing the ASCII code of the first character 
    c[C_SIZE_1] = '\0';
    strncpy(c, s.c_str(), C_SIZE_1);

    u = (unsigned char)c[0];
    i = (int)u;
    i = H_000000FF & i;
    return (unsigned char)i;
}

void UniversalComboAppend::append(unsigned char b) {
    using namespace std;

    char c = (char)b;
    *combo << c;
}

void UniversalComboAppend::append(char c) {
    using namespace std;

    *combo << c;
}

void UniversalComboAppend::append(double d) {
    using namespace std;

    *combo << d;
}

void UniversalComboAppend::append(int i) {
    using namespace std;

    *combo << i;
}

void UniversalComboAppend::append(std::string & s) {
    using namespace std;

    *combo << s;
}

void UniversalComboAppend::separatorFollows(unsigned char b) {
    using namespace std;

    char c = (char)b;
    *combo << c << separator;
}

void UniversalComboAppend::separatorFollows(char c) {
    using namespace std;

    *combo << c << separator;
}

void UniversalComboAppend::separatorFollows(double d) {
    using namespace std;

    *combo << d << separator;
}

void UniversalComboAppend::separatorFollows(int i) {
    using namespace std;

    *combo << i << separator;
}

void UniversalComboAppend::separatorFollows(std::string & s) {
    using namespace std;

    *combo << s << separator;
}

