#ifndef DEVIDE_SJIS_H
#define DEVIDE_SJIS_H

#define D_SIZE 98304
#define F_SIZE 3072
#include <vector>
#include "FieldsArray.h"
#include "Ucombo.h"

typedef std::string (*EditFunction)(std::string & s);
typedef std::vector<std::string> AsQueue;

class DividingSJIS {
protected:
    AsQueue *a;
    bool manyFields[F_SIZE];
    bool remove_separators;
    char ASCII_C, CLEAR_BIT_C, SET_BIT_C;
    char dough[D_SIZE];
    char pattern[F_SIZE];
    FieldsList *f;
    int doughLength;
    int field_count;
    int size_of_united_items;
    std::string combo;
    std::string separator;
    unsigned char ascii_byte;
    unsigned char quote_byte;
    unsigned char separator_byte;

    void vector_to_array_arranging_in_reverse_order();
    void vector_to_array_complementing(std::string & extra, unsigned char bond);
    void vector_to_array_editing(EditFunction editing, int field_number);
    void vector_to_array_mapping();

public:
    ~DividingSJIS();
    DividingSJIS();
    DividingSJIS(unsigned char s);
    DividingSJIS(unsigned char q, unsigned char s, bool e);
    DividingSJIS(unsigned char q, unsigned char s, bool e, unsigned char a);

    int complementing_fields_list(char *buffer, int bufferLength, std::string & extra, unsigned char bond);
    int editing_field(char *buffer, int bufferLength, int field_number);
    int extracting_decimal_from_field(char *buffer, int bufferLength, int field_number);
    int extracting_integer_from_field(char *buffer, int bufferLength, int field_number);
    int fieldCount() const;
    int mapping_fields_list(char *buffer, int bufferLength);
    int reversing_fields_list(char *buffer, int bufferLength);
    int search_separator(char *buffer, int bufferLength, int beginning);
    int smashed_to_pieces(char *buffer, int bufferLength, bool *selected);
    int unitedSize() const;
    std::string reverse_unite(char *buffer, int bufferLength);
    std::string supplying_bits(int c);
    std::string surge_of_set_bits(int c, int interval_0, int interval_1);
    std::string unite(AsQueue *a, UniversalComboAppend *c, char *buffer, int bufferLength);
    std::string unite(char *buffer, int bufferLength);
    std::string unite(char *buffer, int bufferLength, bool listed);
    unsigned char quoteCode() const;
    unsigned char separatorCode() const;
    void setting(FieldsList *fields_list, int c);
    void setting(FieldsList *fields_list, int c, char *pn);
};

#endif // DEVIDE_SJIS_H
