#include "PathEXE.h"

namespace {
    const bool PUT_NEW_LINE = true;
    const char BELL = 7; // 07h, BEL
    const char SEMICOLON = 59; // 3Bh, ';' 
    const char YEN = 92; // 5Ch, '\\' 
    const unsigned char H_5C = 92; // '\\' 
    const int MANY = 256;
    const int Y_SIZE_1 = Y_SIZE - 1;
    const std::string C_ERR = "err";
    const std::string EMPTY = "";
    const std::string TEXT_FILE = ".txt";
}

CommandPath::~CommandPath() {
}

CommandPath::CommandPath(bool m) {
    manyErrorTexts = m;
    exeDirectories();
}

bool CommandPath::openClose(std::string & path_name) {
    using namespace std;

    bool b;
    int error_number;
    stringstream os;

    try {
        ifstream serialFile( path_name.c_str(), ios::binary );
        serialFile.exceptions(ios_base::failbit);
        b = true;
    } catch(...) {
        b = false;
        if( manyErrorTexts ) {
            error_number = 183;
            os << "openClose() error-" << error_number << ": " << path_name;

            ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
            x.setting();
        }

    }

    return b;
}

int CommandPath::exeDirectories() {
    char c[Y_SIZE];

    c[Y_SIZE_1] = '\0';
    strncpy(c, getenv("Path"), Y_SIZE_1);

    return trimming(c, strlen(c) );
}

int CommandPath::trimming(char *s, int s_length) {
    char c = s[0];
    char trace;
    int m = 0;

    for(int k = 1; k <= s_length; ++k) {
        trace = c;
        c = s[k];

        if( c == '\0' ) {
            combo[m++] = trace;
            combo[m] = '\0';
            break;
        } else if( c == SEMICOLON ) {
            if( trace == YEN ) {
                continue; // YEN disappears if followed by SEMICOLON.
            } else {
                combo[m++] = trace;
            }

        } else {
            combo[m++] = trace;
        }

    }

    comboLength = m;
    return comboLength;
}

std::string CommandPath::pathName(std::string & g) {
    int field_count;
    int many_fields = MANY;
    std::string r = EMPTY;

    extra = g;

    FieldsList *f = new FieldsList();
    DividingSJIS *d = new DividingSJIS(SEMICOLON);
    d->setting(f, many_fields);

    field_count = d->complementing_fields_list(combo, comboLength, extra, H_5C);
    full_path = EMPTY;

    for(int i = 1; i <= field_count; ++i) {
        full_path = f->item(i);
        if( openClose(full_path) ) {
            r = full_path;
            break;
        }

    }

    delete f; delete d;
    return r;
}

