CC        = bcc32c
LINKER    = ilink32

INCLUDE = -I"C:\BCC102\include"
LIB     = -L"C:\BCC102\lib\win32c\debug"

CFLAGS = -O2 -w 
LFLAGS = /Tpe /c /ap

TARGET = utf8to16.exe
OBJS   = errortext.obj finaleffect.obj guide.obj hyphenterm.obj messagestext.obj numbered.obj parameters.obj produceutf16.obj readwrite.obj timename.obj utf8to16main.obj 
RESFILES = Utf8to16Resource.res

ALL : $(TARGET)

errortext.obj: ErrorText.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ErrorText.cpp
finaleffect.obj: FinalEffect.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c FinalEffect.cpp
guide.obj: Guide.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Guide.cpp
hyphenterm.obj: HyphenTerm.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c HyphenTerm.cpp
messagestext.obj: MessagesText.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c MessagesText.cpp
numbered.obj: Numbered.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Numbered.cpp
parameters.obj: parameters.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c parameters.cpp
produceutf16.obj: ProduceUTF16.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ProduceUTF16.cpp
readwrite.obj: ReadWrite.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c ReadWrite.cpp
timename.obj: TimeName.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c TimeName.cpp
utf8to16main.obj: Utf8to16Main.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c Utf8to16Main.cpp

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0x32.obj,$(TARGET),,cw32.lib import32.lib,,$(RESFILES)
clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
