#include "HyphenTerm.h"

namespace {
    char C_SETTING_TEXT[] = "C:\\Sjisutf8\\set_utf8to16.txt";
    char SETTING_TEXT[] = "set_utf8to16.txt";
    const char STANDARD_QUOTE_C = 34; // " 
    const double MAXIMUM_DIFFERENCE = 40.0;
    const int C_SIZE_1 = C_SIZE - 1;
    const int CAPITAL_A = 65; // 41h 
    const int CLEAR_BIT = 48; // 30h, "0" 
    const int COMMA = 44; // 2Ch 
    const int DOT_SIZE = 1;
    const int EQUAL_SIZE = 6; // Each field has a width of 6 bytes. 
    const int FIELD_1 = 1;
    const int FINAL_1 = 2147483646; // 7FFFFFFEh 
    const int FINAL_INTEGER = 2147483647; // 7FFFFFFFh 
    const int FIRST_LINE = 1;
    const int GAP = 32; // 20h 
    const int GREATER_THAN = 62; // 3Eh 
    const int H_000000FF = 255;
    const int H_09 = 9; // TAB 
    const int H_0A = 10; // LF 
    const int H_0D = 13; // CR 
    const int H_1A = 26; // end of MS-DOS text file 
    const int H_20 = 32; // SP, GAP 
    const int H_22 = 34; // " 
    const int H_27 = 39; // ' 
    const int H_2C = 44; // , 
    const int H_3C = 60; // < 
    const int H_44 = 68; // D 
    const int H_5F = 95; // _ 
    const int H_7C = 124; // | 
    const int HE = 205; // CDh 
    const int JOINT_PIECE_TERM_SIZE = 2;
    const int JOINT_TERM_SIZE = 2;
    const int LABEL_PIECE_TERM_SIZE = 2;
    const int LABEL_TERM_SIZE = 2;
    const int LESS_THAN = 60; // 3Ch 
    const int LOWER_CASE_L = 108; // 6Ch, l 
    const int LOWER_CASE_S = 115; // 73h, s 
    const int LOWER_CASE_T = 116; // 74h, t 
    const int LOWER_CASE_V = 118; // 76h, v 
    const int LOWER_CASE_X = 120; // 78h, x 
    const int MAXIMUM_FIELD_COUNT = 255;
    const int NOT_CONVERTED = -1;
    const int NOT_COUNTED = 2147483647; // 7FFFFFFFh 
    const int NOT_MEASURED = -1;
    const int QUOTE_PIECE_TERM_SIZE = 2;
    const int QUOTE_TERM_SIZE = 2;
    const int SEPARATOR_PIECE_TERM_SIZE = 2;
    const int SEPARATOR_TERM_SIZE = 2;
    const int SET_BIT = 49; // 31h, "1"
    const int TAB = 9;
    const int UPPER_LIMIT_TO_FIELD_NUMBER = 3071; // F_SIZE - 1
    const int VERTICAL_LINE = 124; // 7Ch 
    const int YEN_C = 92; // 5Ch 
    const std::string AFTER_POINT = "-a";
    const std::string ASCII_1 = " !'#$%&()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~";
    const std::string AT_POINT = "-P";
    const std::string BEFORE_POINT = "-A";
    const std::string BITS = "-e";
    const std::string BYTE_ORDER_MARK = "-m";
    const std::string C_ERR = "err";
    const std::string CAPITAL_CSV = "CSV";
    const std::string CHECK_LENGTH = "-B";
    const std::string COMMAND_NAME = "utf8to16";
    const std::string COMMAND_NAME_FILE = "utf8to16.txt";
    const std::string COUNT_LINES = "-l";
    const std::string CRLF = "-CRLF";
    const std::string DENIED = "-";
    const std::string DO_NOT_REMOVE_TEMPORARY_FILE = "-y";
    const std::string DOT = ".";
    const std::string EMPTY = "";
    const std::string GUIDE_TERM = "-G";
    const std::string H_00TO42 = "x00x01x02x03x04x05x06x07x08x09x0Ax0Bx0Cx0Dx0Ex0Fx10x11x12x13x14x15x16x17x18x19x1Ax1Bx1Cx1Dx1Ex1Fx20x21x22x23x24x25x26x27x28x29x2Ax2Bx2Cx2Dx2Ex2Fx30x31x32x33x34x35x36x37x38x39x3Ax3Bx3Cx3Dx3Ex3Fx40x41x42";
    const std::string H_43TO85 = "x43x44x45x46x47x48x49x4Ax4Bx4Cx4Dx4Ex4Fx50x51x52x53x54x55x56x57x58x59x5Ax5Bx5Cx5Dx5Ex5Fx60x61x62x63x64x65x66x67x68x69x6Ax6Bx6Cx6Dx6Ex6Fx70x71x72x73x74x75x76x77x78x79x7Ax7Bx7Cx7Dx7Ex7Fx80x81x82x83x84x85";
    const std::string H_86TOC8 = "x86x87x88x89x8Ax8Bx8Cx8Dx8Ex8Fx90x91x92x93x94x95x96x97x98x99x9Ax9Bx9Cx9Dx9Ex9FxA0xA1xA2xA3xA4xA5xA6xA7xA8xA9xAAxABxACxADxAExAFxB0xB1xB2xB3xB4xB5xB6xB7xB8xB9xBAxBBxBCxBDxBExBFxC0xC1xC2xC3xC4xC5xC6xC7xC8";
    const std::string H_C9TOFF = "xC9xCAxCBxCCxCDxCExCFxD0xD1xD2xD3xD4xD5xD6xD7xD8xD9xDAxDBxDCxDDxDExDFxE0xE1xE2xE3xE4xE5xE6xE7xE8xE9xEAxEBxECxEDxEExEFxF0xF1xF2xF3xF4xF5xF6xF7xF8xF9xFAxFBxFCxFDxFExFF";
    const std::string HEAD_END = "-h";
    const std::string HELP_TERM = "--help";
    const std::string HYPHEN = "-";
    const std::string IDENTICAL_TIME = "-t";
    const std::string IN_CONTEXT = "-c";
    const std::string INCLUDE_0DH = "-0";
    const std::string INTERVAL_TERM = "-i";
    const std::string JOINT_PIECE_TERM = "-j";
    const std::string JOINT_TERM = "-J";
    const std::string LABEL_PIECE_TERM = "-n";
    const std::string LABEL_TERM = "-N";
    const std::string LF = "-LF";
    const std::string LINE_FEED = "-L";
    const std::string LOWER_CASE_CSV = "csv";
    const std::string N_0TO1 = "01";
    const std::string N_0TO9 = "0123456789";
    const std::string NEAR_POINT = "-X";
    const std::string NEGATIVE_BIT_PATTERN = "-E";
    const std::string PRODUCE_TEMPORARY_BINARY = "-b";
    const std::string QUOTE_PIECE_TERM = "-q";
    const std::string QUOTE_TERM = "-Q";
    const std::string SEPARATOR_PIECE_TERM = "-s";
    const std::string SEPARATOR_TERM = "-S";
    const std::string TAIL_END = "-f";
    const std::string TERM_1_FILE_NAME = "-o";
    const std::string TERM_2_FILE_NAME = "-k";
    const std::string TEXT_FILE = ".txt";
    const std::string UNALTERED = "_";
    const std::string VERSION_WITH_COMMENTS = "-VC";
    const std::string VERSION_WITHOUT_COMMENTS = "-V";
    const std::string YEN = "\\";
}

HyphenTerms::~HyphenTerms() {
}

HyphenTerms::HyphenTerms(ParameterList *L) {
    using namespace std;

    stringstream og;
    stringstream om;
    stringstream os;

    listing = L;
    field_count = UPPER_LIMIT_TO_FIELD_NUMBER;
    GAP_C = (char)H_20;
    NEW_LINE = EMPTY + "\x0D";
    NEW_LINE = NEW_LINE + "\x0A";

    ASCII = ASCII_1 + STANDARD_QUOTE_C;
    CLEAR_BIT_C = (char)CLEAR_BIT;
    SET_BIT_C = (char)SET_BIT;
    TAB_C = (char)H_09;

    os << H_00TO42 << H_43TO85 << H_86TOC8 << H_C9TOFF;
    BYTES = os.str();

    for(int i = 0; i < UPPER_LIMIT_TO_FIELD_NUMBER; ++i) {
        om << CLEAR_BIT_C;
        og << SET_BIT_C;
    }

    EBB = om.str();
    FLOOD = og.str();
}

bool HyphenTerms::binaryRepresented() const {
    return binary_represented; // 10111, for example 
}

bool HyphenTerms::carriageReturn() {
    return deniable[8];
}

bool HyphenTerms::checkLength() {
    return deniable[11];
}

bool HyphenTerms::countLines() {
    return deniable[12];
}

bool HyphenTerms::extensionEqualsCSV(std::string & file_name) {
    using namespace std;

    bool csvFile = false;
    int nameLength, q, tailLength;
    string fileExtension;

    nameLength = file_name.length(); // 8 + 1 + 3 = 12
    q = file_name.find(DOT);

    if( q >= 0 ) { // 8
        q += DOT_SIZE; // 8 + 1 = 9
        tailLength = nameLength - q; // 12 - 9 = 3
        fileExtension = file_name.substr(q, tailLength);
        if( fileExtension == LOWER_CASE_CSV ) {
            csvFile = true;
        } else if( fileExtension == CAPITAL_CSV ) {
            csvFile = true;
        } else {
            csvFile = false;
        }

    }

    return csvFile;
}

bool HyphenTerms::guideFile() {
    return deniable[5];
}

bool HyphenTerms::identicalTime() {
    return deniable[3];
}

bool HyphenTerms::include0Dh() const {
    return carriage_return;
}

bool HyphenTerms::jointPieces(std::string & s) {
    using namespace std;

    bool b = false;
    string head, tail;
    int headLength, k, s_length, tailLength;

    s_length = s.length();
    head = s.substr(0, JOINT_PIECE_TERM_SIZE);
    headLength = head.length();
    tailLength = s_length - headLength;

    if( head == JOINT_PIECE_TERM ) {
        k = headLength;
        tail = s.substr(k, tailLength);
        b = true;
    }

    joint_piece = tail;
    return b;
}

bool HyphenTerms::labelPieces(std::string & s) {
    using namespace std;

    bool b = false;
    string head, tail;
    int headLength, k, s_length, tailLength;

    s_length = s.length();
    head = s.substr(0, LABEL_PIECE_TERM_SIZE);
    headLength = head.length();
    tailLength = s_length - headLength;

    if( head == LABEL_PIECE_TERM ) {
        k = headLength;
        tail = s.substr(k, tailLength);
        b = true;
    }

    label_piece = tail;
    return b;
}

bool HyphenTerms::lineFeed() {
    return deniable[7];
}

bool HyphenTerms::noRemoving() {
    return deniable[4];
}

bool HyphenTerms::produceTemporaryBinary() {
    return deniable[10];
}

bool HyphenTerms::quotePieces(std::string & s) {
    using namespace std;

    bool b = false;
    string head, tail;
    int headLength, k, s_length, tailLength;

    s_length = s.length();
    head = s.substr(0, QUOTE_PIECE_TERM_SIZE);
    headLength = head.length();
    tailLength = s_length - headLength;

    if( head == QUOTE_PIECE_TERM ) {
        k = headLength;
        tail = s.substr(k, tailLength);
        b = true;
    }

    quote_piece = tail;
    return b;
}

bool HyphenTerms::remove0Dh() {
    return deniable[7];
}

bool HyphenTerms::separatorPieces(std::string & s) {
    using namespace std;

    bool b = false;
    string head, tail;
    int headLength, k, s_length, tailLength;

    s_length = s.length();
    head = s.substr(0, SEPARATOR_PIECE_TERM_SIZE);
    headLength = head.length();
    tailLength = s_length - headLength;

    if( head == SEPARATOR_PIECE_TERM ) {
        k = headLength;
        tail = s.substr(k, tailLength);
        b = true;
    }

    separator_piece = tail;
    return b;
}

bool HyphenTerms::versionNumber() {
    return deniable[6];
}

bool HyphenTerms::withBOM() {
    return deniable[9];
}

int HyphenTerms::acquireFromText() {
    using namespace std;

    bool SETTING_TEXT_IS_NOT_ACCESSIBLE;
    const int Q_SIZE_1 = Q_SIZE - 1;
    char c[C_SIZE];
    char name[C_SIZE];
    int k = 1;
    string *p;

    for(int i = 0; i < Q_SIZE; ++i) {
        acquisition[i] = EMPTY;
    }

    try {
        ifstream testFile(C_SETTING_TEXT, ios::binary);
        testFile.exceptions(ios_base::failbit);
        strcpy(name, C_SETTING_TEXT);
        SETTING_TEXT_IS_NOT_ACCESSIBLE = false;
    } catch(...) {
        SETTING_TEXT_IS_NOT_ACCESSIBLE = true;
    }

    if( SETTING_TEXT_IS_NOT_ACCESSIBLE ) {
        try {
            ifstream testFile(SETTING_TEXT, ios::binary);
            testFile.exceptions(ios_base::failbit);
            strcpy(name, SETTING_TEXT);
            SETTING_TEXT_IS_NOT_ACCESSIBLE = false;
        } catch(...) {
            SETTING_TEXT_IS_NOT_ACCESSIBLE = true;
        }
    
    }

    if(! SETTING_TEXT_IS_NOT_ACCESSIBLE ) {
        ifstream settingFile(name);

        if( settingFile.getline(c, C_SIZE) ) {
            string s(c);
            path_name = s;
        }

        p = new string("");
        while( settingFile.getline(c, C_SIZE) ) {
            for(int n = 0; n < C_SIZE; ++n) {
                if( c[n] == TAB_C ) {
                    c[n] = '\0'; // Comments were removed. 
                    break;
                }

            }

            delete p;
            p = new string(c);
            if( p->length() > 0 ) {
                acquisition[k++] = *p;
                if( k > Q_SIZE_1 ) {
                    break;
                }

            }

        }

        delete p;
    }

    return k;
}

int HyphenTerms::afterPoint() {
    const int F = 1;

    if( figure[F] == NOT_CONVERTED ) {
        after = 0;
    } else {
        after = figure[F];
    }

    return after;
}

int HyphenTerms::atPoint() {
    const int F = 3;

    if( figure[F] == NOT_CONVERTED ) {
        focal_point = FIRST_LINE;
    } else {
        focal_point = figure[F];
    }

    return focal_point;
}

int HyphenTerms::beforePoint() {
    const int F = 2;

    if( figure[F] == NOT_CONVERTED ) {
        before = 0;
    } else {
        before = figure[F];
    }

    return before;
}

int HyphenTerms::copyingStringToArray(char *s, int s_length) {
    int m = 0;

    for(int k = 0; k < s_length; ++k) {
        buffer[m++] = s[k];
    }

    return m;
}

int HyphenTerms::hexadecimal_to_integer(std::string & s) {
    using namespace std;

    int q = BYTES.find(s);
    return q/3;
}

int HyphenTerms::intervalFrom() const {
    return interval_from;
}

int HyphenTerms::intervalTo() const {
    return interval_to;
}

int HyphenTerms::tripletAfter() {
    if( triplet_in_context.t[2] < 1 ) {
        inContext();
        if( triplet_in_context.t[2] < 1 ) {
            headEnd();
            if( triplet_in_context.t[2] < 1 ) {
                pattern = singleSurge();
                if( triplet_in_context.t[2] < 1 ) {
                    triplet_in_context.t[0] = 0;
                    triplet_in_context.t[1] = 0;
                    triplet_in_context.t[2] = atPoint();
                }

            }

        }

    }

    return triplet_in_context.t[0];
}

int HyphenTerms::tripletBefore() {
    if( triplet_in_context.t[2] < 1 ) {
        inContext();
        if( triplet_in_context.t[2] < 1 ) {
            headEnd();
            if( triplet_in_context.t[2] < 1 ) {
                pattern = singleSurge();
                if( triplet_in_context.t[2] < 1 ) {
                    triplet_in_context.t[0] = 0;
                    triplet_in_context.t[1] = 0;
                    triplet_in_context.t[2] = atPoint();
                }

            }

        }

    }

    return triplet_in_context.t[1];
}

int HyphenTerms::tripletPoint() {
    if( triplet_in_context.t[2] < 1 ) {
        inContext();
        if( triplet_in_context.t[2] < 1 ) {
            headEnd();
            if( triplet_in_context.t[2] < 1 ) {
                pattern = singleSurge();
                if( triplet_in_context.t[2] < 1 ) {
                  triplet_in_context.t[0] = 0;
                  triplet_in_context.t[1] = 0;
                  triplet_in_context.t[2] = atPoint();
                }

            }

        }

    }

    return triplet_in_context.t[2];
}

std::string HyphenTerms::fileName() const {
    return first_file_name;
}

std::string HyphenTerms::jointPiece() {
    return piece[1];
}

std::string HyphenTerms::joints() {
    using namespace std;

    const int F = 1;
    char c[C_SIZE];
    int u = H_000000FF & byteCode[F];
    string r;
    stringstream os;
    unsigned char b = (unsigned char)u;

    if( piece[F] == UNALTERED ) {
        if( b == 0 ) {
            os << piece[F];
        } else {
            os << b;
        }

    } else {
        os << piece[F];
    }

    r = os.str();
    strcpy(c, r.c_str() );

    joint_byte = (unsigned char)c[0];
    return r;
}

std::string HyphenTerms::labelPiece() {
    return piece[4];
}

std::string HyphenTerms::labels() {
    using namespace std;

    const int F = 4;
    char c[C_SIZE];
    int u = H_000000FF & byteCode[F];
    string r;
    stringstream os;
    unsigned char b = (unsigned char)u;

    if( piece[F] == UNALTERED ) {
        if( b == 0 ) {
            os << piece[F];
        } else {
            os << b;
        }

    } else {
        os << piece[F];
    }

    r = os.str();
    strcpy(c, r.c_str() );

    label_byte = (unsigned char)c[0];
    return r;
}

std::string HyphenTerms::listName(int index) {
    std::string r = EMPTY;

    if( index < 1 ) {
// error 
        exit(108);
    } else {
        if( index > 2 ) {
// error 
            exit(109);
        } else {
            r = list_name[index];
        }

    }

    return r;
}

std::string HyphenTerms::multipleBitPattern() {
    using namespace std;

    const int F = 1;

    int patternLength, q, tailLength, u;
    string c, tail;
    stringstream os;
    unsigned char b;

    pattern = bit_pattern_array[F];
    patternLength = pattern.length();

    u = H_000000FF & CLEAR_BIT;
    b = (unsigned char)u;
    os << b;
    c = os.str();
    q = pattern.find(c);
    if( q >= 0 ) {
        binary_represented = true; // 10111, for example 
    } else {
        binary_represented = false;
    }

    if( patternLength > field_count ) {
        pattern = pattern.substr(0, field_count);
    } else {
        tailLength = field_count - patternLength;
        tail = FLOOD.substr(0, tailLength);
        pattern = bit_pattern_array[F] + tail;
    }

    return pattern;
}

std::string HyphenTerms::negativePattern() {
    using namespace std;

    const int F = 2;

    char d[C_SIZE];
    string combo, tail;
    string s = bit_pattern_array[F];
    stringstream os;
    int s_length, tailLength;

    strcpy(d, s.c_str() );
    s_length = copyingStringToArray(d, s.length() ); // buffer

    binary_represented = false;

// Converting 01000 into 10111 
    for(int k = 0; k < s_length; ++k) {
        if( buffer[k] == CLEAR_BIT_C ) {
            os << SET_BIT_C;
        } else {
            os << CLEAR_BIT_C;
            binary_represented = true; // 10111, for example 
        }

    }

    combo = os.str();
    if( s_length > field_count ) {
        pattern = combo.substr(0, field_count);
    } else {
        tailLength = field_count - s_length;
        tail = FLOOD.substr(0, tailLength);
        pattern = combo + tail;
    }

    return pattern;
}

std::string HyphenTerms::newName() {
    int nameLength = second_file_name.length();

    if( nameLength == 0 ) {
        second_file_name = COMMAND_NAME_FILE;
    }

    return second_file_name;
}

std::string HyphenTerms::pathName() const {
    return path_name;
}

std::string HyphenTerms::quotePiece() {
    return piece[2];
}

std::string HyphenTerms::quotes() {
    using namespace std;

    const int F = 2;
    char c[C_SIZE];
    int u = H_000000FF & byteCode[F];
    string r;
    stringstream os;
    unsigned char b = (unsigned char)u;

    if( piece[F] == UNALTERED ) {
        if( b == 0 ) {
            os << piece[F];
        } else {
            os << b;
        }

    } else {
        os << piece[F];
    }

    r = os.str();
    strcpy(c, r.c_str() );

    quote_byte = (unsigned char)c[0];
    return r;
}

std::string HyphenTerms::separatorPiece() {
    return piece[3];
}

std::string HyphenTerms::separators() {
    using namespace std;

    const int F = 3;
    char c[C_SIZE];
    int u = H_000000FF & byteCode[F];
    string r;
    stringstream os;
    unsigned char b = (unsigned char)u;

    if( piece[F] == UNALTERED ) {
        if( b == 0 ) {
            os << piece[F];
        } else {
            os << b;
        }

    } else {
        os << piece[F];
    }

    r = os.str();
    strcpy(c, r.c_str() );

    separator_byte = (unsigned char)c[0];
    return r;
}

std::string HyphenTerms::singleSurge() { // not Triplet 
    const int F = 1;
    int difference;

    if( (maximum[F] == NOT_CONVERTED) || (minimum[F] == NOT_CONVERTED) ) {
        interval_from = FIRST_LINE;
        interval_to = FIRST_LINE;

        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = 0;
        triplet_in_context.t[2] = 0;
    } else {
        interval_from = minimum[F];
        interval_to = maximum[F];
        difference = interval_to - interval_from;

        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = difference;
        triplet_in_context.t[2] = interval_to;

        if( difference < 0 ) {
// error 
            exit(110);
        }

    }

    pattern = surge_of_set_bits(interval_from, interval_to);
    return pattern;
}

std::string HyphenTerms::surge_of_set_bits(int interval_0, int interval_1) {
    using namespace std;

    int bodyLength, headLength, tailLength;
    string r;
/*
  surge_of_set_bits
0011111000000000000, for example
Setting bits from interval_0 to interval_1
*/
    bodyLength = interval_1 - interval_0 + 1;

    if( bodyLength > field_count ) {
        stringstream om;

        bodyLength = field_count;

        for(int i = 0; i < bodyLength; ++i) {
            om << SET_BIT_C;
        }

        r = om.str();
    } else {
        stringstream os;

        headLength = interval_0 - 1;
        for(int i = 0; i < headLength; ++i) {
            os << CLEAR_BIT_C;
        }

        for(int i = 0; i < bodyLength; ++i) {
            os << SET_BIT_C;
        }

        tailLength = field_count - interval_1;
        for(int i = 0; i < tailLength; ++i) {
            os << CLEAR_BIT_C;
        }

        r = os.str();
    }

    return r;
}

Triplet HyphenTerms::headEnd() {
    const int F = 5;

    if( figure[F] == NOT_CONVERTED ) {
        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = 0;
        triplet_in_context.t[2] = 0;
    } else {
        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = figure[F] - 1;
        triplet_in_context.t[2] = figure[F];
    }

    return triplet_in_context;
}

Triplet HyphenTerms::inContext() {
    const int F = 4;

    if( figure[F] == NOT_CONVERTED ) {
        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = 0;
        triplet_in_context.t[2] = 0;
    } else {
        triplet_in_context.t[0] = figure[F]; // after 
        triplet_in_context.t[1] = figure[F]; // before 
        triplet_in_context.t[2] = atPoint(); // focal_point 
    }

    return triplet_in_context;
}

Triplet HyphenTerms::nearPoint() {
    const int F = 2;
    double d, difference, display_from, display_to, half;

    if( maximum[F] == NOT_CONVERTED ) {
        display_from = 1.0;
        display_to = display_from + MAXIMUM_DIFFERENCE;
    } else {
        display_from = 0.0 + minimum[F];
        display_to = 0.0 + maximum[F];
    }

    d = ( display_from + display_to )/2.0;

    difference = display_to - display_from;
    if( difference < 0.0 ) {
// error 
        display_from = 1.0;
        display_to = display_from + MAXIMUM_DIFFERENCE;

        exit(111);
    } else {
        if( difference > MAXIMUM_DIFFERENCE ) {
            difference = MAXIMUM_DIFFERENCE;
            half = difference/2.0;
            display_from = d - half;
            display_to = display_from + MAXIMUM_DIFFERENCE;
        }

    }

    interval_from = (int)floor(display_from);
    interval_to = (int)floor(display_to);

    d = ( display_from + display_to )/2.0;
    d += 0.5;
    focal_point = (int)floor(d);

    triplet_in_context.t[0] = interval_to - focal_point;
    triplet_in_context.t[1] = focal_point - interval_from;
    triplet_in_context.t[2] = focal_point;
    return triplet_in_context;
}

Triplet HyphenTerms::tailEnd() {
    const int F = 6;

    if( figure[F] == NOT_CONVERTED ) {
        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = 0;
        triplet_in_context.t[2] = 0;
    } else {
        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = figure[F] - 1;
        triplet_in_context.t[2] = NOT_COUNTED; // MeasureSpan::countLines may run. 
    }

    return triplet_in_context;
}

Triplet HyphenTerms::tailEnd(int line_count) {
    const int F = 6;

    if( figure[F] == NOT_CONVERTED ) {
        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = 0;
        triplet_in_context.t[2] = 0;
    } else {
        triplet_in_context.t[0] = 0;
        triplet_in_context.t[1] = figure[F] - 1;
        triplet_in_context.t[2] = line_count;
    }

    return triplet_in_context;
}

unsigned char HyphenTerms::jointByte() const {
    return joint_byte;
}

unsigned char HyphenTerms::jointCode() {
    int u = H_000000FF & byteCode[1];
    return (unsigned char)u;
}

unsigned char HyphenTerms::labelByte() const {
    return label_byte;
}

unsigned char HyphenTerms::labelCode() {
    int u = H_000000FF & byteCode[4];
    return (unsigned char)u;
}

unsigned char HyphenTerms::punctuation(std::string & s, int q) {
    using namespace std;

    char c[C_SIZE];
    string h;
    int k, s_length, trace;
    unsigned char n, r;

    if( q < 1 ) {
        r = COMMA;
    } else {
        s_length = s.length();

        if( q > s_length ) {
            r = COMMA;
        } else {
            trace = q;

            h = s.substr(q, 2); // \l, for example 
            strcpy(c, h.c_str() );
            n = (unsigned char)c[0];

            if( n == YEN_C ) {
/*
0123456789
-S\l
*/
                n = (unsigned char)c[1];

                switch(n) {
                case CAPITAL_A:
                    r = LESS_THAN;
                    break;
                case HE:
                    r = LESS_THAN;
                    break;
                case LOWER_CASE_L:
                    r = VERTICAL_LINE;
                    break;
                case LOWER_CASE_S:
                    r = GAP;
                    break;
                case LOWER_CASE_T:
                    r = TAB;
                    break;
                case LOWER_CASE_V:
                    r = GREATER_THAN;
                    break;
                case LOWER_CASE_X:
/*
0123456789
-S\x7C
*/
                    h = s.substr(3, 3);

                    k = hexadecimal_to_integer(h);
                    k = k & H_000000FF;
                    r = (unsigned char)k;
                    break;
                default:
                    r = COMMA;
                    break;
                }

            } else {
/*
0123456789
-s,
*/
                q = trace;
                h = s.substr(q, 1); // comma, for example 
                strcpy(c, h.c_str() );
                r = (unsigned char)c[0];
            }

        }

    }

    return r;
}

unsigned char HyphenTerms::quoteByte() const {
    return quote_byte;
}

unsigned char HyphenTerms::quoteCode() {
    int u = H_000000FF & byteCode[2];
    return (unsigned char)u;
}

unsigned char HyphenTerms::separatorByte() const {
    return separator_byte;
}

unsigned char HyphenTerms::separatorCode() {
    int u = H_000000FF & byteCode[3];
    return (unsigned char)u;
}

void HyphenTerms::setFieldCount(int c) {
    field_count = c;
}

void HyphenTerms::setting() {
    using namespace std;

    bool firstFile, hyphen_C, hyphen_C_byte_code, hyphen_C_figure, hyphen_C_hyphen, hyphen_C_interval, hyphen_C_pattern, hyphen_C_piece, with_binary;
    int ACQUISITION_ITEM_COUNT, headLength, k, PARAMETER_COUNT, q, s_length, tailLength;
    NumberedTerm *n;
    string body, head, parameter_i, s, tail, z;
    string BEFORE_TRIGGERING_1("-w1");
    string UNNECESSARY_1("-u1");

    bit_pattern_array[1] = FLOOD;
    bit_pattern_array[2] = EBB;
    byteCode[1] = H_5F; // joint_byte 
    byteCode[2] = H_22; // quote_byte 
    byteCode[3] = H_0A; // separator_byte 
    byteCode[4] = H_3C; // label_byte 
    deniable[1] = false;
    deniable[2] = false;
    deniable[3] = false;
    deniable[4] = false;
    deniable[5] = false;
    deniable[6] = false;
    deniable[7] = false;
    deniable[8] = false;
    deniable[9] = false;
    deniable[10] = false;
    deniable[11] = false;
    deniable[12] = false;
    figure[1] = NOT_CONVERTED;
    figure[2] = NOT_CONVERTED;
    figure[3] = NOT_CONVERTED;
    figure[4] = NOT_CONVERTED;
    figure[5] = NOT_CONVERTED;
    figure[6] = NOT_CONVERTED;
    maximum[1] = FINAL_INTEGER;
    maximum[2] = FINAL_INTEGER;
    minimum[1] = NOT_CONVERTED;
    minimum[2] = NOT_CONVERTED;
    piece[1] = UNALTERED;
    piece[2] = UNALTERED;
    piece[3] = UNALTERED;
    piece[4] = UNALTERED;

    list_name[1] = EMPTY;
    list_name[2] = EMPTY;
    firstFile = true;
    first_file_name = EMPTY;
    PARAMETER_COUNT = listing->itemCount();
    second_file_name = EMPTY;

// Two default parameters 
    commandParameter[0] = BYTE_ORDER_MARK;
    commandParameter[1] = INCLUDE_0DH;
    k = 2;

    ACQUISITION_ITEM_COUNT = acquireFromText(); // acquisition[] 
    for(int i = 1; i < ACQUISITION_ITEM_COUNT; ++i) {
        commandParameter[k++] = acquisition[i];
    }

    for(int i = 1; i < PARAMETER_COUNT; ++i) {
        s = listing->item(i);

        if( listing->shorter(i) ) {
            commandParameter[k++] = s; // -f 
        } else {
            if( s == CRLF ) {
                commandParameter[k++] = INCLUDE_0DH;
                continue;
            }

            if( s == HELP_TERM ) {
                commandParameter[k++] = GUIDE_TERM;
                continue;
            }

            if( s == LF ) {
                commandParameter[k++] = INCLUDE_0DH + DENIED;
                commandParameter[k++] = LINE_FEED;
                continue;
            }

            if( s == VERSION_WITH_COMMENTS ) {
                commandParameter[k++] = GUIDE_TERM;
                continue;
            }

            if( listing->hyphenated(i) ) {
                if( listing->character(i) ) { // ASCII, not katakana
                    if( listing->denied(i) ) {
                        commandParameter[k++] = s; // -L- 
                        continue;
                    } else if( listing->referred(i) ) {
                        commandParameter[k++] = s; // -S\x7C 
                        continue;
                    } else if( listing->number(i) ) {
                        commandParameter[k++] = s; // -u2 
                        continue;
                    } else if( quotePieces(s) ) {
                        commandParameter[k++] = s; // -q~ 
                        continue;
                    } else if( separatorPieces(s) ) {
                        commandParameter[k++] = s; // -s, 
                        continue;
                    } else if( jointPieces(s) ) {
                        commandParameter[k++] = s; // -j, 
                        continue;
                    } else if( labelPieces(s) ) {
                        commandParameter[k++] = s; // -nDIR 
                        continue;
                    } else {
/*                      
-0BbLlm   ty            
-0 -B -b -L -l -m -t -y 
*/                      
                        s_length = s.length();
                        for(int w = 1; w < s_length; ++w) {
                            z = s.substr(w, 1);
                            commandParameter[k++] = HYPHEN + z;
                        }

                    }

                } else {
                    commandParameter[k++] = s; // katakana
                }

            } else {
                commandParameter[k++] = s; // text.tmp 
            }

        }

    }

    PARAMETER_COUNT = k;
    char empty[1] = {0};
    n = new NumberedTerm(empty);
    for(int k = 0; k < PARAMETER_COUNT; ++k) {
        s = commandParameter[k];

        hyphen_C = false;
        hyphen_C_byte_code = false;
        hyphen_C_figure = false;
        hyphen_C_hyphen = false;
        hyphen_C_interval = false;
        hyphen_C_pattern = false;
        hyphen_C_piece = false;

        s_length = s.length();
        if( s_length < 1 ) {
            continue;
        }

        head = s.substr(0, 1);
        if( head == HYPHEN ) {
// -0 
            if( s == TERM_1_FILE_NAME ) {
                deniable[1] = true;
                continue;
            } else if( s == TERM_2_FILE_NAME ) {
                deniable[2] = true;
                continue;
            } else if( s == IDENTICAL_TIME ) {
                deniable[3] = true;
                continue;
            } else if( s == DO_NOT_REMOVE_TEMPORARY_FILE ) {
                deniable[4] = true;
                continue;
            } else if( s == GUIDE_TERM ) {
                deniable[5] = true;
                continue;
            } else if( s == VERSION_WITHOUT_COMMENTS ) {
                deniable[6] = true;
                continue;
            } else if( s == LINE_FEED ) {
                deniable[7] = true;
                continue;
            } else if( s == INCLUDE_0DH ) {
                deniable[8] = true;
                continue;
            } else if( s == BYTE_ORDER_MARK ) {
                deniable[9] = true;
                continue;
            } else if( s == PRODUCE_TEMPORARY_BINARY ) {
                deniable[10] = true;
                continue;
            } else if( s == CHECK_LENGTH ) {
                deniable[11] = true;
                continue;
            } else if( s == COUNT_LINES ) {
                deniable[12] = true;
                continue;
            } else {
                hyphen_C = true; // other parameters 
            }

        }

        if( hyphen_C ) {
// -L- 
            if( s_length >= 3 ) {
                tail = s.substr(2, 1);
                if( tail == HYPHEN ) {
                    parameter_i = s; // setting will recover s. 
                    s = s.substr(0, 2);
                    if( s == TERM_1_FILE_NAME ) {
                        deniable[1] = false;
                        list_name[1] = EMPTY;
                        continue;
                    } else if( s == TERM_2_FILE_NAME ) {
                        deniable[2] = false;
                        list_name[2] = EMPTY;
                        continue;
                    } else if( s == IDENTICAL_TIME ) {
                        deniable[3] = false;
                        continue;
                    } else if( s == DO_NOT_REMOVE_TEMPORARY_FILE ) {
                        deniable[4] = false;
                        continue;
                    } else if( s == GUIDE_TERM ) {
                        deniable[5] = false;
                        continue;
                    } else if( s == VERSION_WITHOUT_COMMENTS ) {
                        deniable[6] = false;
                        continue;
                    } else if( s == LINE_FEED ) {
                        deniable[7] = false;
                        continue;
                    } else if( s == INCLUDE_0DH ) {
                        deniable[8] = false;
                        continue;
                    } else if( s == BYTE_ORDER_MARK ) {
                        deniable[9] = false;
                        continue;
                    } else if( s == PRODUCE_TEMPORARY_BINARY ) {
                        deniable[10] = false;
                        continue;
                    } else if( s == CHECK_LENGTH ) {
                        deniable[11] = false;
                        continue;
                    } else if( s == COUNT_LINES ) {
                        deniable[12] = false;
                        continue;
                    } else {
                        hyphen_C_hyphen = true; // other parameters 
                    }

                    s = parameter_i; // setting has recovered s. 
                }

            }

        }

        if( hyphen_C || hyphen_C_hyphen ) {
// -a2 
            if( s_length >= 3 ) {
                tail = s.substr(2, 1);
                q = N_0TO9.find(tail);
                if( q >= 0 ) {
                    delete n;
                    n = new NumberedTerm(s);
                    if( n->parameter() == AFTER_POINT ) {
                        figure[1] = n->number();
                        continue;
                    } else if( n->parameter() == BEFORE_POINT ) {
                        figure[2] = n->number();
                        continue;
                    } else if( n->parameter() == AT_POINT ) {
                        figure[3] = n->number();
                        continue;
                    } else if( n->parameter() == IN_CONTEXT ) {
                        figure[4] = n->number();
                        continue;
                    } else if( n->parameter() == HEAD_END ) {
                        figure[5] = n->number();
                        continue;
                    } else if( n->parameter() == TAIL_END ) {
                        figure[6] = n->number();
                        continue;
                    } else {
                        hyphen_C_figure = true; // other parameters 
                    }

                }

            }

        }

        if( hyphen_C || hyphen_C_figure || hyphen_C_hyphen ) {
/*
 -i2   
 -i2,3 
 -i2-3 
 0123456789
*/
            if( s_length >= 3 ) {
                body = s.substr(2, 1);
                q = N_0TO9.find(body);
                if( q >= 0 ) {
                    delete n;
                    n = new NumberedTerm(s, FINAL_1);
                    if( n->trimmedSequence() ) {
                        if( n->parameter() == INTERVAL_TERM ) {
                            maximum[1] = n->number();
                            minimum[1] = n->subnumber();
                            continue;
                        } else if( n->parameter() == NEAR_POINT ) {
                            maximum[2] = n->number();
                            minimum[2] = n->subnumber();
                            continue;
                        } else {
                            hyphen_C_interval = true; // other parameters 
                        }

                    }

                }

            }

        }

        if( hyphen_C || hyphen_C_figure || hyphen_C_hyphen || hyphen_C_interval ) {
/*
 -e10111 
 0123456789
*/
            c[C_SIZE_1] = '\0';
            strncpy(c, s.c_str(), C_SIZE_1);
            with_binary = ( s_length < 3 ) ? false : true;

            for(int i = 2; i < s_length; ++i) {
                q = N_0TO1.find(c[i]);
                if( q < 0 ) {
                    with_binary = false;
                    break;
                }

            }

            if( with_binary ) {
                headLength = 2;
                head = s.substr(0, headLength);
                tailLength = s_length - headLength;
                tail = s.substr(2, tailLength);

                if( head == BITS ) {
                    bit_pattern_array[1] = tail;
                    continue;
                } else if( head == NEGATIVE_BIT_PATTERN ) {
                    bit_pattern_array[2] = tail;
                    continue;
                } else {
                    hyphen_C_pattern = true; // other parameters 
                }

            }

        }

        if( hyphen_C || hyphen_C_figure || hyphen_C_hyphen || hyphen_C_interval || hyphen_C_pattern ) {
            head = s.substr(0, JOINT_TERM_SIZE);
            if( head == JOINT_TERM ) {
/*
 -S\l   
 -S\x7C 
 0123456789
*/
                byteCode[1] = punctuation(s, JOINT_TERM_SIZE);
                if( byteCode[1] == 0 ) {
                    hyphen_C_byte_code = true; // other parameters 
                } else {
                    continue;
                }

            } else {
                head = s.substr(0, QUOTE_TERM_SIZE);
                if( head == QUOTE_TERM ) {
                    byteCode[2] = punctuation(s, QUOTE_TERM_SIZE);
                    if( byteCode[2] == 0 ) {
                        hyphen_C_byte_code = true; // other parameters 
                    } else {
                        continue;
                    }

                } else {
                    head = s.substr(0, SEPARATOR_TERM_SIZE);
                    if( head == SEPARATOR_TERM ) {
                        byteCode[3] = punctuation(s, SEPARATOR_TERM_SIZE);
                        if( byteCode[3] == 0 ) {
                            hyphen_C_byte_code = true; // other parameters 
                        } else {
                            continue;
                        }

                    } else {
                        head = s.substr(0, LABEL_TERM_SIZE);
                        if( head == LABEL_TERM ) {
                            byteCode[4] = punctuation(s, LABEL_TERM_SIZE);
                            if( byteCode[4] == 0 ) {
                                hyphen_C_byte_code = true; // other parameters 
                            } else {
                                continue;
                            }

                        } else {
                            hyphen_C_byte_code = true; // other parameters 
                        }

                    }

                }

            }

        }

        if( hyphen_C || hyphen_C_byte_code || hyphen_C_figure || hyphen_C_hyphen || hyphen_C_interval || hyphen_C_pattern ) {
            if( s_length >= 3 ) {
                headLength = 2;
                head = s.substr(0, headLength);
                tailLength = s_length - headLength;
                tail = s.substr(2, tailLength);

                if( head == JOINT_PIECE_TERM ) {
// -j, 
                    piece[1] = tail;
                    byteCode[1] = 0; // Regardless of -J, software recognizes that -j has priority. 
                    continue;
                } else if( head == QUOTE_PIECE_TERM ) {
// -q~ 
                    piece[2] = tail;
                    byteCode[2] = 0; // Regardless of -Q, software recognizes that -q has priority. 
                    continue;
                } else if( head == SEPARATOR_PIECE_TERM ) {
// -s, 
                    piece[3] = tail;
                    byteCode[3] = 0; // Regardless of -S, software recognizes that -s has priority. 
                    continue;
                } else if( head == LABEL_PIECE_TERM ) {
// -nDIR 
                    piece[4] = tail;
                    byteCode[4] = 0; // Regardless of -N, software recognizes that -n has priority. 
                    continue;
                } else {
                    hyphen_C_piece = true; // other parameters 
                }

            }

        }

        if( hyphen_C || hyphen_C_byte_code || hyphen_C_figure || hyphen_C_hyphen || hyphen_C_interval || hyphen_C_pattern || hyphen_C_piece ) {
            continue; // setting omitted s from parameters. 
        }

        if( deniable[1] ) {
// TERM_1_FILE_NAME 
            list_name[1] = s;
            deniable[1] = false;
        } else if( deniable[2] ) {
// TERM_2_FILE_NAME 
            list_name[2] = s;
            deniable[2] = false;
        } else if( firstFile ) {
            first_file_name = s;
            firstFile = false;
        } else {
            second_file_name = s;
        }

    }

    delete n;
}

