#include "ProduceUTF16.h"

AsArray CLEAR_AS_ARRAY;

namespace {
    char BOM[3] = {255, 254, 0}; // FFh, FEh, '\0'
    char TEMPORARY_BINARY[] = "binary.tmp";
    const bool PUT_NEW_LINE = true;
    const char CLEAR_BIT_C = 48; // 30h, '0' 
    const char H_0A_C = 10; // LF 
    const char H_0D_C = 13; // CR 
    const char SET_BIT_C = 49; // 31h, '1'
    const int B_110110 = 54;
    const int B_110111 = 55;
    const int BOM_LENGTH = 2; // FFh, FEh 
    const int BOM_SIZE = 3; // EFh, BBh, BFh 
    const int BUFFER_ERROR = -1;
    const int CLEAR_BIT = 48; // 30h, '0' 
    const int COMBO_ERROR = -3;
    const int EXPANSION_FACTOR = 3;
    const int FILE_ERROR = -2;
    const int H_00000001 = 1;
    const int H_00010000 = 65536;
    const int H_00FF = 255;
    const int H_0A = 10; // LF 
    const int H_0D = 13; // CR 
    const int H_10000000 = 128; // 80h 
    const int H_11000000 = 192; // C0h 
    const int H_11100000 = 224; // E0h 
    const int H_11110000 = 240; // F0h 
    const int H_30 = 48; // '0' 
    const int H_31 = 49; // '1' 
    const int H_39 = 57; // '9' 
    const int H_3E = 62; // '>' 
    const int H_3F = 63;
    const int H_41 = 65; // 'A' 
    const int H_42 = 66; // 'B' 
    const int H_46 = 70; // 'F' 
    const int H_5F = 95; // '_' 
    const int H_7E = 126; // '~' 
    const int H_80 = 128;
    const int H_BB = 187;
    const int H_BF = 191;
    const int H_D840 = 55360;
    const int H_DC02 = 56322;
    const int H_EF = 239;
    const int H_FE = 254;
    const int H_FF = 255;
    const int KANJI_PART_1 = 3;
    const int KANJI_PART_2 = 4;
    const int KANJI_PART_3 = 5;
    const int KANJI_SIZE = 2;
    const int NOT_CONVERTED = -1;
    const int REMOVED = -5;
    const int SET_BIT = 49; // 31h, '1'
    const int SIZE_OF_CHAR = 2;
    const int SIZE_OF_SURROGATE_PAIR = 4;
    const int SURROGATE_PAIR_PART_1 = 6;
    const int SURROGATE_PAIR_PART_2 = 7;
    const int SURROGATE_PAIR_PART_3 = 8;
    const int SURROGATE_PAIR_PART_4 = 9;
    const int TWO_BYTE_CHARACTER_PART_1 = 1;
    const int TWO_BYTE_CHARACTER_PART_2 = 2;
    const int W_SIZE_1 = W_SIZE - 1;
    const int WHOLE_ASCII = 0;
    const int ZERO_LENGTH_ERROR = -4;
    const std::string C_ERR = "err";
    const std::string EMPTY = "";
    const std::string TEXT_FILE = ".txt";
}

CodePoint::~CodePoint() {
    delete[] buffer;
    delete[] combo;
}

CodePoint::CodePoint(std::string fn) {
    buffer_size = -1;
    file_name = fn;
    with_BOM = true;
}

CodePoint::CodePoint(std::string fn, bool wb) {
    buffer_size = -1;
    file_name = fn;
    with_BOM = wb;
}

AsArray CodePoint::produce_UTF16_phrase(char *s, int s_length) {
using namespace std;
    bool proceed_to_the_counting_stage = false;
    int k;
    int m = 0;
    unsigned char u;

    a = CLEAR_AS_ARRAY;
    carriage_return_appears = false;
    count = 0;

// Finding the first NEW_LINE 
    unknown_mode = true;
    for(int n = beginning; n < s_length; ++n) {
        if( m >= W_SIZE_1 ) {
            break;
        }

        u = (unsigned char)s[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count = 1;
            proceed_to_the_counting_stage = true;
            beginning = n + 1;

            a.v[m] = H_0A_C;
            a.v[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            a.v[m] = H_0D_C;
            a.v[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            carriage_return_appears = true;
            NEW_LINE_SIZE = 2; // 0Dh and 0Ah 
            NEW_LINE = EMPTY + H_0D_C;
            NEW_LINE = NEW_LINE + H_0A_C;
            break;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(a.v, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(a.v, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(a.v, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(a.v, k, m);
                break;
            default:
                break;
            }

            break;
        }

        if( proceed_to_the_counting_stage ) {
            break;
        }

    }

    if( beginning > 0 ) {
// Counting lines 
        unknown_mode = true;
        for(int n = beginning; n < s_length; ++n) { // the_counting_stage
            if( m >= W_SIZE_1 ) {
                break;
            }

            u = (unsigned char)s[n];
            k = (int)u;

            switch(k) {
            case H_0A:
                count += 1;

                a.v[m] = H_0A_C;
                a.v[ m + 1 ] = 0;
                m += SIZE_OF_CHAR;

                break;
            case H_0D:
                a.v[m] = H_0D_C;
                a.v[ m + 1 ] = 0;
                m += SIZE_OF_CHAR;
                break;
            default:
                if( unknown_mode ) {
                    group_part_mode = checkGroupPartMode(k);
                }

                switch(group_part_mode) {
                case 0:
                    m = bits_of_WHOLE_ASCII(a.v, k, m);
                    break;
                case 1:
                    bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                    break;
                case 2:
                    m = bits_of_TWO_BYTE_CHARACTER_PART_2(a.v, k, m);
                    break;
                case 3:
                    bits_of_KANJI_PART_1(k);
                    break;
                case 4:
                    bits_of_KANJI_PART_2(k);
                    break;
                case 5:
                    m = bits_of_KANJI_PART_3(a.v, k, m);
                    break;
                case 6:
                    bits_of_SURROGATE_PAIR_PART_1(k);
                    break;
                case 7:
                    bits_of_SURROGATE_PAIR_PART_2(k);
                    break;
                case 8:
                    bits_of_SURROGATE_PAIR_PART_3(k);
                    break;
                case 9:
                    m = bits_of_SURROGATE_PAIR_PART_4(a.v, k, m);
                    break;
                default:
                    break;
                }

                break;
            }

        }

    }

    a.v_length = m;
    return a;
}

AsArray CodePoint::reading_to_produce_UTF16() {
    using namespace std;

    bool proceed_to_the_counting_stage = false;
    int block_has_been_read, error_number, k;
    int m = 0;
    stringstream os;
    unsigned char u;

    a = CLEAR_AS_ARRAY;
    carriage_return_appears = false;
    count = 0;

// Reading and copying the file to produce a large buffer
    try {
        ifstream testFile( file_name.c_str() );
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 250;
        os << "reading_to_produce_UTF16() error-" << error_number << ": " << file_name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream nameFile( file_name.c_str(), ios::binary );
    while( m < buffer_size ) {
        nameFile.read(y, Y_SIZE);
        block_has_been_read = nameFile.gcount();
        if( block_has_been_read == 0 ) {
            break;
        }

        for(int n = 0; n < Y_SIZE; ++n) {
            buffer[m++] = y[n];
            if( m < buffer_size ) {
                continue;
            } else {
                break;
            }

        }

    }

// Finding the first NEW_LINE 
    m = 0;
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) {
        beginning = n + 1;
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count = 1;
            proceed_to_the_counting_stage = true;

            a.v[m] = H_0A_C;
            a.v[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            a.v[m] = H_0D_C;
            a.v[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            carriage_return_appears = true;
            NEW_LINE_SIZE = 2; // 0Dh and 0Ah 
            NEW_LINE = EMPTY + H_0D_C;
            NEW_LINE = NEW_LINE + H_0A_C;
            break;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(a.v, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(a.v, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(a.v, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(a.v, k, m);
                break;
            default:
                break;
            }

            break;
        }

        if( proceed_to_the_counting_stage ) {
            break;
        }

    }

// Counting lines 
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) { // the_counting_stage
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count += 1;

            a.v[m] = H_0A_C;
            a.v[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            a.v[m] = H_0D_C;
            a.v[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;
            break;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(a.v, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(a.v, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(a.v, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(a.v, k, m);
                break;
            default:
                break;
            }

            break;
        }

    }

    a.v_length = m;
    return a;
}

bool CodePoint::setting() {
    using namespace std;

    bool b;
    int error_number;
    stringstream os;
    unsigned char q[3];

    try {
        ifstream testFile( file_name.c_str() );
        testFile.exceptions(ios_base::failbit);
        b = true;
    } catch(...) {
        b = false;
        error_number = 251;
        os << "setting() error-" << error_number << ": " << file_name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream textFile( file_name.c_str(), ios::binary );
    textFile.read(p, P_SIZE);

    q[0] = (unsigned char)p[0];
    q[1] = (unsigned char)p[1];
    q[2] = (unsigned char)p[2];
    if( q[0] == H_EF && q[1] == H_BB && q[2] == H_BF ) {
        beginning = BOM_SIZE;
    } else {
        beginning = 0;
    }

    buffer_size = (int)file_size(file_name);
    combo_size = EXPANSION_FACTOR * buffer_size;

    B_110110_S = B_110110 << 10;
    B_110111_S = B_110111 << 10;

    E_table();

    NEW_LINE = EMPTY + H_0A_C;
    NEW_LINE_SIZE = 1;

    B[0] = 1;
    B[1] = 2;
    B[2] = 4;
    B[3] = 8;
    B[4] = 16;
    B[5] = 32;
    B[6] = 64;
    B[7] = 128;
    B[8] = 256;
    B[9] = 512;
    B[10] = 1024;
    B[11] = 2048;
    B[12] = 4096;
    B[13] = 8192;
    B[14] = 16384;
    B[15] = 32768;
    B[16] = 65536;
    B[17] = 131072;
    B[18] = 262144;
    B[19] = 524288;
    B[20] = 1048576;

    H[0] = 1;
    H[1] = 16;
    H[2] = 256;
    H[3] = 4096;
    H[4] = 65536;
    H[5] = 1048576;
    H[6] = 16777216;
    H[7] = 268435456;

    LOWER_PART_MASK = 1 + 2 + 4 + 8 + 16 + 32 + 64 + 128 + 256 + 512;

    setBufferSize();
    return b;
}

bool CodePoint::setting(int bs) {
    using namespace std;

    bool b;
    int error_number;
    stringstream os;
    unsigned char q[3];

    try {
        ifstream testFile( file_name.c_str() );
        testFile.exceptions(ios_base::failbit);
        b = true;
    } catch(...) {
        b = false;
        error_number = 251;
        os << "setting() error-" << error_number << ": " << file_name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream textFile( file_name.c_str(), ios::binary );
    textFile.read(p, P_SIZE);

    q[0] = (unsigned char)p[0];
    q[1] = (unsigned char)p[1];
    q[2] = (unsigned char)p[2];
    if( q[0] == H_EF && q[1] == H_BB && q[2] == H_BF ) {
        beginning = BOM_SIZE;
    } else {
        beginning = 0;
    }

    buffer_size = bs;
    combo_size = EXPANSION_FACTOR * buffer_size;

    B_110110_S = B_110110 << 10;
    B_110111_S = B_110111 << 10;

    E_table();

    NEW_LINE = EMPTY + H_0A_C;
    NEW_LINE_SIZE = 1;

    B[0] = 1;
    B[1] = 2;
    B[2] = 4;
    B[3] = 8;
    B[4] = 16;
    B[5] = 32;
    B[6] = 64;
    B[7] = 128;
    B[8] = 256;
    B[9] = 512;
    B[10] = 1024;
    B[11] = 2048;
    B[12] = 4096;
    B[13] = 8192;
    B[14] = 16384;
    B[15] = 32768;
    B[16] = 65536;
    B[17] = 131072;
    B[18] = 262144;
    B[19] = 524288;
    B[20] = 1048576;

    H[0] = 1;
    H[1] = 16;
    H[2] = 256;
    H[3] = 4096;
    H[4] = 65536;
    H[5] = 1048576;
    H[6] = 16777216;
    H[7] = 268435456;

    LOWER_PART_MASK = 1 + 2 + 4 + 8 + 16 + 32 + 64 + 128 + 256 + 512;

    if( buffer_size > 0 ) {
        setBufferSize();
    }

    return b;
}

int CodePoint::bufferingWriting(int comboLength) {
    using namespace std;

    int n = 0;
    ofstream newFile( new_name.c_str(), ios::binary );

    if( with_BOM ) {
        newFile.write(BOM, BOM_LENGTH);
    }

    y_length = Y_SIZE;
    while( n < comboLength ) {
        for(int k = 0; k < Y_SIZE; ++k) {
            y[k] = combo[n++];
            if( n < comboLength ) {
                continue;
            } else {
                y_length = k + 1;
                break;
            }

        }

        newFile.write(y, y_length);
    }

    return n; // n == comboLength
}

char CodePoint::copyingArrayItem(int index) {
    char r;

    if( index < 0 ) {
        r = '\0';
    } else if( index > W_SIZE_1 ) {
        r = '\0';
    } else {
        r = a.v[index];
    }

    return r;
}

int CodePoint::checkGroupPartMode(int k) {
    int n = WHOLE_ASCII;

    if( k < H_80 ) {
        n = WHOLE_ASCII;
        unknown_mode = false;
    } else if( k >= H_11110000 ) {
        n = SURROGATE_PAIR_PART_1;
        unknown_mode = false;
    } else if( k >= H_11100000 ) {
        n = KANJI_PART_1;
        unknown_mode = false;
    } else if( k >= H_11000000 ) {
        n = TWO_BYTE_CHARACTER_PART_1;
        unknown_mode = false;
    } else {
/*
  WHOLE_ASCII = 0;
  TWO_BYTE_CHARACTER_PART_1 = 1;
  TWO_BYTE_CHARACTER_PART_2 = 2;
  KANJI_PART_1 = 3;
  KANJI_PART_2 = 4;
  KANJI_PART_3 = 5;
  SURROGATE_PAIR_PART_1 = 6;
  SURROGATE_PAIR_PART_2 = 7;
  SURROGATE_PAIR_PART_3 = 8;
  SURROGATE_PAIR_PART_4 = 9;
*/
        switch(group_part_mode) {
        case 1:
            n = TWO_BYTE_CHARACTER_PART_2;
            break;
        case 3:
            n = KANJI_PART_2;
            break;
        case 4:
            n = KANJI_PART_3;
            break;
        case 6:
            n = SURROGATE_PAIR_PART_2;
            break;
        case 7:
            n = SURROGATE_PAIR_PART_3;
            break;
        case 8:
            n = SURROGATE_PAIR_PART_4;
            break;
        default:
            break;
        }

        unknown_mode = false;
    }

    return n;
}

int CodePoint::bits_of_KANJI_PART_1(int k) {
    int n;

    for(int i = 0; i < B_SIZE; ++i) {
        pattern[i] = 0;
    }

    n = k - H_11100000;
    pattern[3] = n & H_00000001;

    n = n >> 1;
    pattern[2] = n & H_00000001;

    n = n >> 1;
    pattern[1] = n & H_00000001;

    n = n >> 1;
    pattern[0] = n & H_00000001;

    group_part_mode = KANJI_PART_2;
    return KANJI_PART_2;
}

int CodePoint::bits_of_KANJI_PART_2(int k) {
    int n;

    n = k - H_10000000;
    pattern[9] = n & H_00000001;

    n = n >> 1;
    pattern[8] = n & H_00000001;

    n = n >> 1;
    pattern[7] = n & H_00000001;

    n = n >> 1;
    pattern[6] = n & H_00000001;

    n = n >> 1;
    pattern[5] = n & H_00000001;

    n = n >> 1;
    pattern[4] = n & H_00000001;

    group_part_mode = KANJI_PART_3;
    return KANJI_PART_3;
}

int CodePoint::bits_of_KANJI_PART_3(char *p, int k, int m) {
    int n, q, r, u;

    n = k - H_10000000;
    pattern[15] = n & H_00000001;

    n = n >> 1;
    pattern[14] = n & H_00000001;

    n = n >> 1;
    pattern[13] = n & H_00000001;

    n = n >> 1;
    pattern[12] = n & H_00000001;

    n = n >> 1;
    pattern[11] = n & H_00000001;

    n = n >> 1;
    pattern[10] = n & H_00000001;

// second byte 
    q = 0;
    u = 0;
    for(int i = 15; i >= 8; --i) {
        if( pattern[i] == H_00000001 ) {
            q = q + B[u];
        }

        ++u;
    }

    p[m] = (char)q; // little-endian architecture 

// first byte 
    r = 0;
    u = 0;
    for(int i = 7; i >= 0; --i) {
        if( pattern[i] == H_00000001 ) {
            r = r + B[u];
        }

        ++u;
    }

    p[ m + 1 ] = (char)r;
    m += SIZE_OF_CHAR;

    unknown_mode = true;
    return m;
}

int CodePoint::bits_of_SURROGATE_PAIR_PART_1(int k) {
    int n;

    for(int i = 0; i < B_SIZE; ++i) {
        pattern[i] = 0;
    }

    n = k - H_11110000;
    pattern[2] = n & H_00000001;

    n = n >> 1;
    pattern[1] = n & H_00000001;

    n = n >> 1;
    pattern[0] = n & H_00000001;

    group_part_mode = SURROGATE_PAIR_PART_2;
    return SURROGATE_PAIR_PART_2;
}

int CodePoint::bits_of_SURROGATE_PAIR_PART_2(int k) {
    int n;

    n = k - H_10000000;
    pattern[8] = n & H_00000001;

    n = n >> 1;
    pattern[7] = n & H_00000001;

    n = n >> 1;
    pattern[6] = n & H_00000001;

    n = n >> 1;
    pattern[5] = n & H_00000001;

    n = n >> 1;
    pattern[4] = n & H_00000001;

    n = n >> 1;
    pattern[3] = n & H_00000001;

    group_part_mode = SURROGATE_PAIR_PART_3;
    return SURROGATE_PAIR_PART_3;
}

int CodePoint::bits_of_SURROGATE_PAIR_PART_3(int k) {
    int n;

    n = k - H_10000000;
    pattern[14] = n & H_00000001;

    n = n >> 1;
    pattern[13] = n & H_00000001;

    n = n >> 1;
    pattern[12] = n & H_00000001;

    n = n >> 1;
    pattern[11] = n & H_00000001;

    n = n >> 1;
    pattern[10] = n & H_00000001;

    n = n >> 1;
    pattern[9] = n & H_00000001;

    group_part_mode = SURROGATE_PAIR_PART_4;
    return SURROGATE_PAIR_PART_4;
}

int CodePoint::bits_of_SURROGATE_PAIR_PART_4(char *p, int k, int m) {
    int basic_code, code_point, n, q, u;

    n = k - H_10000000;
    pattern[20] = n & H_00000001;

    n = n >> 1;
    pattern[19] = n & H_00000001;

    n = n >> 1;
    pattern[18] = n & H_00000001;

    n = n >> 1;
    pattern[17] = n & H_00000001;

    n = n >> 1;
    pattern[16] = n & H_00000001;

    n = n >> 1;
    pattern[15] = n & H_00000001;

    q = 0;
    u = 0;
    for(int i = 20; i >= 0; --i) {
        if( pattern[i] == H_00000001 ) {
            q = q + B[u];
        }

        ++u;
    }

    code_point = q;

// Four bytes of UTF-16 
    basic_code = code_point - H_00010000;
    k = basic_code >> 10;
    higher_part_of_kanji = k + B_110110_S;

    k = higher_part_of_kanji & H_00FF;
    p[m] = (char)k; // little-endian architecture 

    k = higher_part_of_kanji >> 8;
    k = k & H_00FF;
    p[ m + 1 ] = (char)k;
    m += KANJI_SIZE;

    basic_code = code_point - H_00010000;
    k = basic_code & LOWER_PART_MASK;
    lower_part_of_kanji = k + B_110111_S;

    k = lower_part_of_kanji & H_00FF;
    p[m] = (char)k; // little-endian architecture 

    k = lower_part_of_kanji >> 8;
    k = k & H_00FF;
    p[ m + 1 ] = (char)k;
    m += KANJI_SIZE;

    unknown_mode = true;
    return m;
}

int CodePoint::bits_of_TWO_BYTE_CHARACTER_PART_1(int k) {
    int n;

    for(int i = 0; i < B_SIZE; ++i) {
        pattern[i] = 0;
    }

    n = k - H_11000000;
    pattern[4] = n & H_00000001;

    n = n >> 1;
    pattern[3] = n & H_00000001;

    n = n >> 1;
    pattern[2] = n & H_00000001;

    n = n >> 1;
    pattern[1] = n & H_00000001;

    n = n >> 1;
    pattern[0] = n & H_00000001;

    group_part_mode = TWO_BYTE_CHARACTER_PART_2;
    return TWO_BYTE_CHARACTER_PART_2;
}

int CodePoint::bits_of_TWO_BYTE_CHARACTER_PART_2(char *p, int k, int m) {
    int n, q, r, u;

    n = k - H_10000000;
    pattern[10] = n & H_00000001;

    n = n >> 1;
    pattern[9] = n & H_00000001;

    n = n >> 1;
    pattern[8] = n & H_00000001;

    n = n >> 1;
    pattern[7] = n & H_00000001;

    n = n >> 1;
    pattern[6] = n & H_00000001;

    n = n >> 1;
    pattern[5] = n & H_00000001;

// second byte 
    q = 0;
    u = 0;
    for(int i = 10; i >= 3; --i) {
        if( pattern[i] == H_00000001 ) {
            q = q + B[u];
        }

        ++u;
    }

    p[m] = (char)q; // little-endian architecture 

// first byte 
    r = 0;
    u = 0;
    for(int i = 2; i >= 0; --i) {
        if( pattern[i] == H_00000001 ) {
            r = r + B[u];
        }

        ++u;
    }

    p[ m + 1 ] = (char)r;
    m += SIZE_OF_CHAR;

    unknown_mode = true;
    return m;
}

int CodePoint::bits_of_WHOLE_ASCII(char *p, int k, int m) {
    p[m] = (char)k;
    p[ m + 1 ] = 0;
    m += SIZE_OF_CHAR;

    unknown_mode = true;
    return m;
}

int CodePoint::E_table() {
    int beginning_of_E, end_1, h, m;

    for(int i = 0; i <= H_FF; ++i) {
        E[i] = NOT_CONVERTED;
    }

// 0 to 9 
    beginning_of_E = H_30;

    end_1 = H_39 - 1;
    E[H_30] = 0;
    h = E[H_30];
    m = H_31;

    for(int k = beginning_of_E; k <= end_1; ++k) {
        ++h;
        E[m++] = h;
    }

// A to F 
    beginning_of_E = H_41;

    end_1 = H_46 - 1;
    E[H_41] = 10; // "A" 
    h = E[H_41];
    m = H_42;

    for(int k = beginning_of_E; k <= end_1; ++k) {
        ++h;
        E[m++] = h;
    }

    return h; // 'F' 
}

int CodePoint::lineCount() const {
    return count;
}

int CodePoint::produceBinaryFile(std::string & name, bool no_removing) {
    using namespace std;

    int block_has_been_read, error_number;
    int sum = 0;
    ofstream newFile(TEMPORARY_BINARY, ios::binary);
    stringstream os;

    try {
        ifstream testFile( name.c_str() );
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 252;
        os << "produceBinaryFile() error-" << error_number << ": " << name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream nameFile( name.c_str(), ios::binary );

    for(;;) {
        nameFile.read(y, Y_SIZE);
        block_has_been_read = nameFile.gcount();
        if( block_has_been_read == 0 ) {
            break;
        }

        newFile.write(y, block_has_been_read);
        sum += block_has_been_read;
    }

    nameFile.close();
    if(! no_removing ) {
        remove( name.c_str() );
    }

    return sum;
}

int CodePoint::reading_to_produce_UTF16_CRLF(std::string & nn) {
    using namespace std;

    bool proceed_to_the_counting_stage = false;
    int block_has_been_read, error_number, k;
    int m = 0;
    stringstream os;
    unsigned char u;

    carriage_return_appears = false;
    count = 0;
    new_name = nn;

// Reading and copying the file to produce a large buffer
    try {
        ifstream testFile( file_name.c_str() );
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 253;
        os << "reading_to_produce_UTF16_CRLF() error-" << error_number << ": " << file_name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream nameFile( file_name.c_str(), ios::binary );
    while( m < buffer_size ) {
        nameFile.read(y, Y_SIZE);
        block_has_been_read = nameFile.gcount();
        if( block_has_been_read == 0 ) {
            break;
        }

        for(int n = 0; n < Y_SIZE; ++n) {
            buffer[m++] = y[n];
            if( m < buffer_size ) {
                continue;
            } else {
                break;
            }

        }

    }

// Finding the first NEW_LINE 
    m = 0;
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) {
        beginning = n + 1;
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count = 1;
            proceed_to_the_counting_stage = true;

            combo[m] = H_0D_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            combo[m] = H_0A_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            carriage_return_appears = true;
            NEW_LINE_SIZE = 2; // 0Dh and 0Ah 
            NEW_LINE = EMPTY + H_0D_C;
            NEW_LINE = NEW_LINE + H_0A_C;
            break;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(combo, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(combo, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(combo, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(combo, k, m);
                break;
            default:
                break;
            }

            break;
        }

        if( proceed_to_the_counting_stage ) {
            break;
        }

    }

// Counting lines 
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) { // the_counting_stage
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count += 1;

            combo[m] = H_0D_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            combo[m] = H_0A_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            continue;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(combo, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(combo, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(combo, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(combo, k, m);
                break;
            default:
                break;
            }

            break;
        }

    }

    return bufferingWriting(m);
}

int CodePoint::reading_to_produce_UTF16_LF(std::string & nn) {
    using namespace std;

    bool proceed_to_the_counting_stage = false;
    int block_has_been_read, error_number, k;
    int m = 0;
    stringstream os;
    unsigned char u;

    carriage_return_appears = false;
    count = 0;
    new_name = nn;

// Reading and copying the file to produce a large buffer
    try {
        ifstream testFile( file_name.c_str() );
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 254;
        os << "reading_to_produce_UTF16_LF() error-" << error_number << ": " << file_name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream nameFile( file_name.c_str(), ios::binary );
    while( m < buffer_size ) {
        nameFile.read(y, Y_SIZE);
        block_has_been_read = nameFile.gcount();
        if( block_has_been_read == 0 ) {
            break;
        }

        for(int n = 0; n < Y_SIZE; ++n) {
            buffer[m++] = y[n];
            if( m < buffer_size ) {
                continue;
            } else {
                break;
            }

        }

    }

// Finding the first NEW_LINE 
    m = 0;
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) {
        beginning = n + 1;
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count = 1;
            proceed_to_the_counting_stage = true;

            combo[m] = H_0A_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            carriage_return_appears = true;
            NEW_LINE_SIZE = 2; // 0Dh and 0Ah 
            NEW_LINE = EMPTY + H_0D_C;
            NEW_LINE = NEW_LINE + H_0A_C;
            break;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(combo, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(combo, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(combo, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(combo, k, m);
                break;
            default:
                break;
            }

            break;
        }

        if( proceed_to_the_counting_stage ) {
            break;
        }

    }

// Counting lines 
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) { // the_counting_stage
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count += 1;

            combo[m] = H_0A_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            continue;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(combo, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(combo, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(combo, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(combo, k, m);
                break;
            default:
                break;
            }

            break;
        }

    }

    return bufferingWriting(m);
}

int CodePoint::reading_to_produce_UTF16_text(std::string & nn) {
    using namespace std;

    bool proceed_to_the_counting_stage = false;
    int block_has_been_read, error_number, k;
    int m = 0;
    stringstream os;
    unsigned char u;

    carriage_return_appears = false;
    count = 0;
    new_name = nn;

// Reading and copying the file to produce a large buffer
    try {
        ifstream testFile( file_name.c_str() );
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 255;
        os << "reading_to_produce_UTF16_text() error-" << error_number << ": " << file_name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    ifstream nameFile( file_name.c_str(), ios::binary );
    while( m < buffer_size ) {
        nameFile.read(y, Y_SIZE);
        block_has_been_read = nameFile.gcount();
        if( block_has_been_read == 0 ) {
            break;
        }

        for(int n = 0; n < Y_SIZE; ++n) {
            buffer[m++] = y[n];
            if( m < buffer_size ) {
                continue;
            } else {
                break;
            }

        }

    }

// Finding the first NEW_LINE 
    m = 0;
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) {
        beginning = n + 1;
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count = 1;
            proceed_to_the_counting_stage = true;

            combo[m] = H_0A_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            combo[m] = H_0D_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            carriage_return_appears = true;
            NEW_LINE_SIZE = 2; // 0Dh and 0Ah 
            NEW_LINE = EMPTY + H_0D_C;
            NEW_LINE = NEW_LINE + H_0A_C;
            break;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(combo, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(combo, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(combo, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(combo, k, m);
                break;
            default:
                break;
            }

            break;
        }

        if( proceed_to_the_counting_stage ) {
            break;
        }

    }

// Counting lines 
    unknown_mode = true;
    for(int n = beginning; n < buffer_size; ++n) { // the_counting_stage
        u = (unsigned char)buffer[n];
        k = (int)u;

        switch(k) {
        case H_0A:
            count += 1;

            combo[m] = H_0A_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;

            break;
        case H_0D:
            combo[m] = H_0D_C;
            combo[ m + 1 ] = 0;
            m += SIZE_OF_CHAR;
            break;
        default:
            if( unknown_mode ) {
                group_part_mode = checkGroupPartMode(k);
            }

            switch(group_part_mode) {
            case 0:
                m = bits_of_WHOLE_ASCII(combo, k, m);
                break;
            case 1:
                bits_of_TWO_BYTE_CHARACTER_PART_1(k);
                break;
            case 2:
                m = bits_of_TWO_BYTE_CHARACTER_PART_2(combo, k, m);
                break;
            case 3:
                bits_of_KANJI_PART_1(k);
                break;
            case 4:
                bits_of_KANJI_PART_2(k);
                break;
            case 5:
                m = bits_of_KANJI_PART_3(combo, k, m);
                break;
            case 6:
                bits_of_SURROGATE_PAIR_PART_1(k);
                break;
            case 7:
                bits_of_SURROGATE_PAIR_PART_2(k);
                break;
            case 8:
                bits_of_SURROGATE_PAIR_PART_3(k);
                break;
            case 9:
                m = bits_of_SURROGATE_PAIR_PART_4(combo, k, m);
                break;
            default:
                break;
            }

            break;
        }

    }

    return bufferingWriting(m);
}

int CodePoint::renameBinaryFile(std::string & name, bool no_removing) {
    using namespace std;

    char c[C_SIZE];
    int block_has_been_read, error_number;
    int sum = 0;
    stringstream os;

    try {
        ifstream testFile(TEMPORARY_BINARY);
        testFile.exceptions(ios_base::failbit);
    } catch(...) {
        error_number = 256;
        os << "renameBinaryFile() error-" << error_number << ": " << name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    if( no_removing ) {
        ifstream nameFile(TEMPORARY_BINARY, ios::binary);
        ofstream newFile( name.c_str(), ios::binary );

        for(;;) {
            nameFile.read(y, Y_SIZE);
            block_has_been_read = nameFile.gcount();
            if( block_has_been_read == 0 ) {
                break;
            }

            newFile.write(y, block_has_been_read);
            sum += block_has_been_read;
        }

    } else {
        strcpy(c, name.c_str() );
        if( rename(TEMPORARY_BINARY, c) ) {
            remove(c);
            sum = REMOVED;
            rename(TEMPORARY_BINARY, c);
        }

    }

    return sum;
}

int CodePoint::setBufferSize() {
    using namespace std;

    int r = buffer_size;
    int error_number;
    stringstream os;

    try {
        buffer = new char[buffer_size];
    } catch(...) {
        r = BUFFER_ERROR;
        error_number = 257;
        os << "setBufferSize() error-" << error_number << ": " << "buffer_size = " << buffer_size;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
    }

    try {
        combo = new char[combo_size];
    } catch(...) {
        r = COMBO_ERROR;
        error_number = 258;
        os << "setBufferSize() error-" << error_number << ": " << "combo_size = " << combo_size;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
    }

    return r;
}

long CodePoint::file_size(std::string & name) {
    using namespace std;

    int error_number;
    long length;
    stringstream os;

    try {
        ifstream testFile( name.c_str(), ios::binary | ios::ate );
        testFile.exceptions(ios_base::failbit);

        length = (long)testFile.tellg();
    } catch(...) {
        length = FILE_ERROR;
        error_number = 259;
        os << "file_size() error-" << error_number << ": " << name;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    if( length == 0 ) {
        length = ZERO_LENGTH_ERROR;
        error_number = 260;
        os << "file_size() error-" << error_number << ": length = " << length;

        ErrorTexts x(C_ERR, TEXT_FILE, os.str(), PUT_NEW_LINE);
        x.setting();
        exit(error_number);
    }

    return length;
}

std::string CodePoint::newLine() const {
    return NEW_LINE;
}

void CodePoint::ifErrorOccurs(int exit_code) {
    if( buffer_size < 0 ) {
        exit(exit_code);
    }

}

